// -*- coding: utf-8 -*-
/*
    TOMUSS: The Online Multi User Simple Spreadsheet
    Copyright (C) 2012 Thierry EXCOFFIER, Universite Claude Bernard

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
*/

function set_rounding(value, column)
{
  column.do_rounding = function(v) { return v.toFixed ? tofixed(v) : v ; } ;
  
  if ( column.historical_comment )
    return '' ;
  
  column.need_update = true ;
  if ( value === '' )
  {
    column.round_by = undefined ;
    return '' ;
  }
  value = Number(value) ;
  if ( value < 0 )
    value = -value ;
  if ( value < 0.001 )
    value = 0.001 ;
  column.round_by = value ;

  // Complex formulas because 9.999 must be displayed as 9.99 an not 10

  if ( value >= 1 )
    column.do_rounding = function(v) { return v ; } ;
  else if ( (10*value) % 1 === 0 )
    column.do_rounding = function(v) {
      return v.toFixed ? (Math.floor(v*10+0.0000001)/10).toFixed(1) : v ;} ;
  else if ( (100*value) % 1 === 0 )
    column.do_rounding = function(v) {
      return v.toFixed ? (Math.floor(v*100+0.0000001)/100).toFixed(2) : v ;} ;
  else if ( (1000*value) % 1 === 0 )
    column.do_rounding = function(v) {
      return v.toFixed ? (Math.floor(v*1000+0.0000001)/1000).toFixed(3) : v ;} ;
    
  return value ;
}

